#ifndef __event
#define __event

#include <iostream>
#include "defs.h"
#include <string>
using namespace std;

class Event
	{
	private:
		msg  type;				// type of event
		long time;				// time of event
		long  exid;				// exchange id
		int  tx;
		int  rx;
		long begin;				// time exchange begins transmission (ie time of RTSOn)
		int  dur;


		void putType(char* s)
			{
			switch(type)
				{
				case null:	    	strcpy(s,"NULL");			break;
				case RTSOn:	    	strcpy(s,"RTSOn");			break;
				case RTSOff:	    strcpy(s,"RTSOff");			break;
				case CTSOn:         strcpy(s,"CTSOn");			break;
				case CTSOff:        strcpy(s,"CTSOff");			break;
				case DATAOn:        strcpy(s,"DATAOn");			break;
				case DATAOff:       strcpy(s,"DATAOff");		break;
				case ACKOn:         strcpy(s,"ACKOn");			break;
				case ACKOff:        strcpy(s,"ACKOff");			break;
				case NoReplyToRTS:  strcpy(s,"NoReplyToRTS");	break;
				case NoReplyToDATA: strcpy(s,"NoReplyToData");	break;
                case NoReplyToBTrOn:strcpy(s,"NoReplyToBTrOn");	break;
				default:	    	strcpy(s,"???");
				}
			}

	public:
		Event() 
			{ type = null; }
		Event( int tt, int rr, msg m, long t, long e, int du, long g)
			{ tx = tt; rx = rr; type = m; time = t; exid = e; dur = du; begin = g;}

		msg  getType() { return type; }
		long getTime() { return time; }
		long getExid() { return exid; }
		int  getTx()   { return tx; }
		int  getRx()   { return rx; }
		long getGen()  { return begin; }
		int  getDur()  { return dur; }
		bool isOn()	   
			{
			if(type == RTSOn || type == CTSOn || type == DATAOn || type == ACKOn)
				return true;

			return false;
			}

		void reschedule(long d) { time = d; }				// Reschedule event
		void setExid(int e)     { exid = e; }
		void display(char* s)
			{
			char t[15];
			putType(t);
			
			if(type==null)
				{
				sprintf(s," Type: %s\n",t);
				return;
				}

			sprintf(s," Type: %s Tx: %d Rx: %d Time: %d ID: %d Began Transmission: %d\n",t,tx,rx,time,exid,begin);
			}
	};
		
#endif