#ifndef __node
#define __node

#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include "defs.h"
#include "event.h"
#include "seeds.h"
#include "log.h"

//class Event;
class EventList;
class Simulator;
//class Seeds;

struct NAV
	{
	long time;			// Time when NAV ends
	int  exid;			// Exchange that is taking place
    int tx;

	NAV() { time = 0; exid = 0; tx=-1;}
	};

class node
	{
	private:
		static int id_counter;
		static Log* log;
		static EventList* eventList;
        static Simulator* sim;

		int  id;										// unique node id
		bool trans[numNodes];							// interfering transmissions
		int  numTrans;									// number of transmissions taking place
		Event Ongoing;									// ongoing overheard transmission

        Seeds ranks;
        NAV   nav;

        int waitingCTS;

        ifstream tgsfile;

        long nextSlotTime(long now)
        	{ return MINISLOTTIME * (now / MINISLOTTIME +1); }

	public:
		node();
        ~node();

		int  identify() { return id; }
		static void setStatic(EventList* el, Log* l, Simulator* s)
				{ eventList = el; log = l; sim = s; }
        void tick()	{ ranks.tick(); }

		void scheduleFirst();							// Schedule first transmission
		void scheduleNew(long,Event);							// Schedule new transmission
		void notify(Event);								// Node may process event
		void receive(Event);							// Notify this node of a broadcast
	};

#endif