#ifndef __node
#define __node

#include <stdlib.h>
#include <math.h>
#include <fstream.h>
#include "defs.h"
#include "event.h"
#include "log.h"

class Event;
class Simulator;

// NAV: Network Allocation vector
// if iRx is true then I am the receiver of this exchange and I will not defer transmissions
//  that are part of this exchange. I will defer new transmissions.
// if iRx is false I will defer ALL transmissions.
struct NAV
	{
	long time;			// Time when NAV ends
	int  exid;			// Exchange that is taking place
	bool iRx;			// I am the Rx of this exchange

	NAV() { time = 0; exid = 0; iRx = false;}
	};

class node
	{
	private:
		static int id_counter;
		static Log* log;
        static node* nodes;

		int  id;										// unique node id
		bool trans[numNodes];							// interfering transmissions
		int  numTrans;									// number of transmissions taking place
		Event Ongoing;									// ongoing overheard transmission
        Event nextTx;

		NAV nav;										// This nav is for overheard exchanges

		int waitingCTS;									// If these packets don't arrive
		int waitingACK;									//   a reTx is necessary

        ifstream tgsfile;

        void readNextTx(long);

	public:
		node();
        ~node();

		int  identify() { return id; }
		static void setStatic(node* n)
				{ nodes = n; }

		void tick(long time);		//(Event, Simulator* sim);				// Node may process event
		void receive(Event);				// Notify this node of a broadcast
		void reply(long time);
	};

#endif